//############################################################################
// ~ International Laser Display Association ~
// ~     ILDA File Format Driver in C++      ~
// ~             Built for EZFB              ~
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#ifndef __EZ_ILDA_COMMON_DEFINITIONS__
#define __EZ_ILDA_COMMON_DEFINITIONS__

//############################################################################
#include "ez_ilda_macros.hpp"

//############################################################################
extern const double pi         ;
extern const double two_pi     ;
extern const double half_pi    ;
extern const double one_degree ; // in radians
extern const double one_radian ; // in degrees

//############################################################################
//                        delta_02, delta_01, delta_12,
inline double delta_angle(double a, double b, double c) // sss triangle
{
    double angle;
    //------------------------------------------------------------------------
    if(    b == 0.0
        || c == 0.0
      )
        angle = 0;
    //------------------------------------------------------------------------
    else if(a == 0)
        angle = pi;
    //------------------------------------------------------------------------
    else if(a >= b + c)
        angle = 0;
    //------------------------------------------------------------------------
    else
        angle = pi - acos((b*b + c*c - a*a)/(2*b*c));
    //------------------------------------------------------------------------
#if 0 //EZ_ILDA_DEBUG_MESSAGES
    cout << " a= "
         << a
         << " b= "
         << b
         << " c= "
         << c
         << " angle= "
         << angle
         << " ";
#endif
    //------------------------------------------------------------------------
    return angle;
}

//############################################################################
inline double simple_2D_angle(double x1, double y1, double x2, double y2)
{
    return atan2(y2 - y1, x2 - x1);
}

//############################################################################
bool     get_dxf_pair          (ifstream& in, int& group_code, string& entity_string);
void     ez_ilda_terminate     (int sig);
string   call_command          (string command, void(*my_exit)(int), bool tee);
void     show_tag              ();
string   ez_MAC_address_string ();
//############################################################################
#endif

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################



