//############################################################################
// ~ International Laser Display Association ~
// ~     ILDA file format driver in C++      ~
// ~             built for EZFB              ~
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#include "ez_ilda.hpp"
    
//############################################################################
int distance_points(const ez_ilda_point p1, const ez_ilda_point p2)
{
    return (int)(ceil((p1 | p2) / ez_ilda_pointer->distance_delta_max));
}

//############################################################################
int dwell_points(double angle) // zero to pi radians
{
    return (int)(ceil(    angle / pi // zero to one
                       * (    ez_ilda_pointer->wave_sample_rate
                           * (ez_ilda_pointer->longest_dwell_microsec / 1000000.0)
                         )
                     )
                );
}

//############################################################################
double cpu_speed()
{
    double  cpu_freq;
    string  command_return,
            command_string  = "grep 'cpu MHz' /proc/cpuinfo";

    command_return = call_command(command_string, ez_ilda_terminate, false);
    cpu_freq = atof(command_return.substr(command_return.find (":",0) + 1).c_str()) * 1000000.0;
    cout << "cpu frequency  : " << cpu_freq << endl << endl;
    return cpu_freq;
}

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################



